from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String, Boolean, Int

Blobtools_Plot_V0_1_0 = CommandToolBuilder(tool="blobtools_plot", base_command=["blobtools", "plot"], inputs=[ToolInput(tag="in_in_file", input_type=File(optional=True), prefix="--infile", doc=InputDocumentation(doc="BlobDB file (created with 'blobtools create')")), ToolInput(tag="in_lib", input_type=String(optional=True), prefix="--lib", doc=InputDocumentation(doc="Plot only certain covlib(s). Separated by ','")), ToolInput(tag="in_no_title", input_type=Boolean(optional=True), prefix="--notitle", doc=InputDocumentation(doc="Do not add filename as title to plot")), ToolInput(tag="in_file_label", input_type=Boolean(optional=True), prefix="--filelabel", doc=InputDocumentation(doc="Label axis based on filenames")), ToolInput(tag="in_plot_groups", input_type=Int(optional=True), prefix="--plotgroups", doc=InputDocumentation(doc="Number of (taxonomic) groups to plot, remaining\ngroups are placed in 'other' [default: 8]")), ToolInput(tag="in_length", input_type=Int(optional=True), prefix="--length", doc=InputDocumentation(doc="Minimum sequence length considered for plotting [default: 100]")), ToolInput(tag="in_c_index", input_type=Boolean(optional=True), prefix="--cindex", doc=InputDocumentation(doc="Colour blobs by 'c index' [default: False]")), ToolInput(tag="in_no_hit", input_type=Boolean(optional=True), prefix="--nohit", doc=InputDocumentation(doc="Hide sequences without taxonomic annotation [default: False]")), ToolInput(tag="in_no_scale", input_type=Boolean(optional=True), prefix="--noscale", doc=InputDocumentation(doc="Do not scale sequences by length [default: False]")), ToolInput(tag="in_legend", input_type=Boolean(optional=True), prefix="--legend", doc=InputDocumentation(doc="Plot legend of blobplot in separate figure")), ToolInput(tag="in_multiplot", input_type=Boolean(optional=True), prefix="--multiplot", doc=InputDocumentation(doc="Multi-plot. Print blobplot for each (taxonomic) group separately")), ToolInput(tag="in_cumulative", input_type=Boolean(optional=True), prefix="--cumulative", doc=InputDocumentation(doc="Print plot after addition of each (taxonomic) group")), ToolInput(tag="in_sort", input_type=String(optional=True), prefix="--sort", doc=InputDocumentation(doc="Sort order for plotting [default: span]")), ToolInput(tag="in_sort_first", input_type=Boolean(optional=True), prefix="--sort_first", doc=InputDocumentation(doc="<L1,L2,...>    Labels that should always be plotted first, regardless of sort order\n('no-hit,other,undef' is often a useful setting)")), ToolInput(tag="in_hist", input_type=String(optional=True), prefix="--hist", doc=InputDocumentation(doc="Data for histograms [default: span]")), ToolInput(tag="in_rank", input_type=String(optional=True), prefix="--rank", doc=InputDocumentation(doc="Taxonomic rank used for colouring of blobs [default: phylum]\n(Supported: species, genus, family, order,\nphylum, superkingdom)")), ToolInput(tag="in_tax_rule", input_type=String(optional=True), prefix="--taxrule", doc=InputDocumentation(doc="Taxrule which has been used for computing taxonomy\n(Supported: bestsum, bestsumorder) [default: bestsum]")), ToolInput(tag="in_format", input_type=String(optional=True), prefix="--format", doc=InputDocumentation(doc="Figure format for plot (png, pdf, eps, jpeg,\nps, svg, svgz, tiff) [default: png]")), ToolInput(tag="in_no_blobs", input_type=Boolean(optional=True), prefix="--noblobs", doc=InputDocumentation(doc="Omit blobplot [default: False]")), ToolInput(tag="in_no_reads", input_type=Boolean(optional=True), prefix="--noreads", doc=InputDocumentation(doc="Omit plot of reads mapping [default: False]")), ToolInput(tag="in_out", input_type=String(optional=True), prefix="--out", doc=InputDocumentation(doc="Output prefix")), ToolInput(tag="in_label", input_type=String(optional=True), prefix="--label", doc=InputDocumentation(doc="Relabel (taxonomic) groups, can be used several times.\ne.g. 'A=Actinobacteria,Proteobacteria'")), ToolInput(tag="in_colours", input_type=File(optional=True), prefix="--colours", doc=InputDocumentation(doc="File containing colours for (taxonomic) groups. This allows having more than 9 colours.")), ToolInput(tag="in_exclude", input_type=String(optional=True), prefix="--exclude", doc=InputDocumentation(doc="Exclude these (taxonomic) groups (also works for 'other')\ne.g. 'Actinobacteria,Proteobacteria,other'")), ToolInput(tag="in_ref_cov", input_type=File(optional=True), prefix="--refcov", doc=InputDocumentation(doc="File containing number of 'total' and 'mapped' reads\nper coverage file. (e.g.: bam0,900,100). If provided, info\nwill be used in read coverage plot(s).")), ToolInput(tag="in_cat_colour", input_type=File(optional=True), prefix="--catcolour", doc=InputDocumentation(doc="Colour plot based on categories from FILE\n(format : 'seq     category').\n"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Blobtools_Plot_V0_1_0().translate("wdl", allow_empty_container=True)

